// Define
#define dirPin 2
#define stepPin 3
#define forward 10
#define backward 9
#define stepsPerRevolution 7
#define stopbackward 4
#define stopforward 5
#define clean 7
#define pause 2000
#define pause2 250
#define pause3 175
#define cleanstep 900
#define positionf 8
#define positionb 12

int forwards = 0;
int backwards = 0;
int stopforwards = 0;
int stopbackwards = 0;
int steps;
int cleans = 0;
int centredist = 0;
int steps2;
int steps3;
int fullrot = 420;

void setup() {
  Serial.begin(9600);
  pinMode(stepPin, OUTPUT);
  pinMode(dirPin, OUTPUT);
  pinMode(positionf, OUTPUT);
  pinMode(positionb, OUTPUT);
  
  pinMode(forward, INPUT);
  pinMode(backward, INPUT);
  pinMode(stopforward, INPUT);
  pinMode(stopbackward, INPUT);
  pinMode(clean, INPUT);
  
  while (!digitalRead(stopforward)){
    digitalWrite(dirPin,HIGH);
    digitalWrite(stepPin, HIGH);
    delayMicroseconds(pause);
    digitalWrite(stepPin,LOW);
    delayMicroseconds(pause);
  }
  for (int i = 0; i < 400; i++){
    digitalWrite(dirPin, LOW);
    digitalWrite(stepPin, HIGH);
    delayMicroseconds(pause);
    digitalWrite(stepPin,LOW);
    delayMicroseconds(pause);
  }
  steps=0;
  steps3=0;
}

void loop() {
  forwards = digitalRead(forward);
  backwards = digitalRead(backward);
  stopforwards = digitalRead(stopforward);
  stopbackwards = digitalRead(stopbackward);
  cleans = digitalRead(clean);
  steps2=(steps*30)/35;
  //Serial.print(steps2);
  //Serial.println();

  /* Moved your stop command out of the loop - what you also could do is attach a (digital) interrupt to call the code anytime*/
  if(stopforwards == HIGH || stopbackwards == HIGH) {
    digitalWrite(stepPin, LOW);
  }
  else {
    /* i assume only one condition can enter at a point in time - so if one condition is met, we'll kinda skip the others*/
    if(forwards==HIGH) {
      digitalWrite(dirPin, HIGH);
      moveIt(true);
      digitalWrite(positionf,HIGH);
      delay(pause3);
      digitalWrite(positionf,LOW);
      delay(pause2);
    }
    else if (backwards == HIGH) {
      digitalWrite(dirPin, LOW);
      moveIt(false);
      digitalWrite(positionb,HIGH);
      delay(pause3);
      digitalWrite(positionb,LOW);
      delay(pause2);
      // Serial.print(steps);
      // Serial.println(’ ');
    }
    else if (cleans == HIGH) {
      cleanIt();
    }
  }
  //I usually send an update once per loop in most of my projects so i combine all the values i'm interrested in in one string that gets sent over to V4
  Serial.print("S"); //Start character
  Serial.print(steps); //First value
  Serial.print(";"); //Seperating character
  Serial.print(steps2); //Second value
  Serial.print("X"); // Stop Character
  Serial.println();

  //In V4 you can use the Tokenizer node to "sum up" the serial communication and then use the seperate node to split your string in your values
}

void moveIt(bool moveforward) {
  for (int i = 0; i < stepsPerRevolution; i++) {
    // These four lines result in 1 step:
      /* This will never be executed inside the for loop, since you dont check the value of the button inside - if you want to check it here read the value inside the if condition
      stopforwards = digitalRead(stopforward);
      stopbackwards = digitalRead(stopbackward);
      if (stopforwards == HIGH || stopbackwards == HIGH){
        digitalWrite(stepPin, LOW);
        break;
      }*/
      digitalWrite(stepPin, HIGH);
      delayMicroseconds(pause);
      digitalWrite(stepPin, LOW);
      delayMicroseconds(pause);

      if(moveforward) {
        steps=steps+1;
        steps3=steps3+1;
      }
      else {
        steps=steps-1;
        steps3=steps3-1;
      }
    }
}

void cleanIt() {
  bool moveforward;
  if(steps>0) {
    digitalWrite(dirPin, LOW);
    moveforward = false;
  }
  else {
    digitalWrite(dirPin, HIGH);
    moveforward = true;
  }
  for (int i = 0; i < fullrot; i++){
        /*stopforwards = digitalRead(stopforward);
        stopbackwards = digitalRead(stopbackward);
        if (stopforwards == HIGH || stopbackwards == HIGH){
          digitalWrite(stepPin, LOW);
          break;
        }*/
        digitalWrite(stepPin, HIGH);
        delayMicroseconds(pause);
        digitalWrite(stepPin, LOW);
        delayMicroseconds(pause);
        if(moveforward) {
          steps3=steps3+1;
        }
        else {
          steps3=steps3-1;
        }
      }
}
